package com.gic.haoban.manage.service.service.out.impl.hm;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.haoban.base.api.common.errCode.HaoBanErrCodeCommon;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.hm.HmWelcomeRelationDTO;
import com.gic.haoban.manage.api.dto.welcome.qdto.QueryWelcomeRelationQDTO;
import com.gic.haoban.manage.api.service.hm.HmWelcomeRelationApiService;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanWelcomeTemplateRelationMapper;
import com.gic.haoban.manage.service.entity.hm.TabHaobanWelcomeTemplateRelation;
import com.gic.haoban.manage.service.pojo.qo.WelcomeRelationQO;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Author MUSI
 * @Date 2022/7/4 10:52 AM
 * @Description
 * @Version
 **/
@Component(value = "hmWelcomeRelationApiServiceImpl")
public class HmWelcomeRelationApiServiceImpl implements HmWelcomeRelationApiService {

    @Autowired
    private TabHaobanWelcomeTemplateRelationMapper welcomeTemplateRelationMapper;
    /**
     * 条件查询 欢迎语关联关系
     *
     * @param queryWelcomeRelationQDTO
     * @return
     */
    @Override
    public ServiceResponse<Page<HmWelcomeRelationDTO>> queryWelcomeRelation(QueryWelcomeRelationQDTO queryWelcomeRelationQDTO) {
        if (queryWelcomeRelationQDTO.getWelcomeId() == null){
            return ServiceResponse.failure(HaoBanErrCodeCommon.ERR_2.getCode()+"", HaoBanErrCodeCommon.ERR_2.getMsg());
        }
        WelcomeRelationQO welcomeRelationQo = new WelcomeRelationQO();
        welcomeRelationQo.setWelcomeId(queryWelcomeRelationQDTO.getWelcomeId());
        PageHelper.startPage(queryWelcomeRelationQDTO.getPageNum(), queryWelcomeRelationQDTO.getPageSize());
        com.github.pagehelper.Page<TabHaobanWelcomeTemplateRelation> tabHaobanWelcomeTemplateRelations =
                (com.github.pagehelper.Page<TabHaobanWelcomeTemplateRelation>) welcomeTemplateRelationMapper.queryWelcomeTemplate(welcomeRelationQo);
        Page<HmWelcomeRelationDTO> hmWelcomeRelationDTOPage = PageUtil.changePageHelperToCurrentPage(tabHaobanWelcomeTemplateRelations, HmWelcomeRelationDTO.class);
        return ServiceResponse.success(hmWelcomeRelationDTOPage);
    }
}
